devproject/urls.py
from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin
from django.utils import timezone
from django.views.decorators.cache import cache_page
from django.views.decorators.http import last_modified
from django.views.i18n import JavaScriptCatalog

from misago.users.forms.auth import AdminAuthenticationForm


admin.autodiscover()
admin.site.login_form = AdminAuthenticationForm


urlpatterns = [
    url(r"^", include("misago.urls", namespace="misago")),
    url(r"^", include("social_django.urls", namespace="social")),
    # Javascript translations
    url(
        r"^django-i18n.js$",
        last_modified(lambda req, **kw: timezone.now())(
            cache_page(86400 * 2, key_prefix="misagojsi18n")(
                JavaScriptCatalog.as_view(packages=["misago"])
            )
        ),
        name="django-i18n",
    ),
    # Uncomment next line if you plan to use Django admin for 3rd party apps
    url(r"^django-admin/", admin.site.urls),
]


# If debug mode is enabled, include debug toolbar
if settings.DEBUG:
    import debug_toolbar

    urlpatterns += [url(r"^__debug__/", include(debug_toolbar.urls))]


# Use static file server for static and media files (debug only)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)


# Error Handlers
# Misago needs those handlers to deal with errors raised by it's middlewares
# If you replace those handlers with custom ones, make sure you decorate them
# with shared_403_exception_handler or shared_404_exception_handler
# decorators that are defined in misago.views.errorpages module!
handler403 = "misago.core.errorpages.permission_denied"
handler404 = "misago.core.errorpages.page_not_found"

misago/admin/urls.py
from django.conf.urls import url

from .. import admin
from .views import auth, index

urlpatterns = [
    # "misago:admin:index" link symbolises "root" of Misago admin links space
    # any request with path that falls below this one is assumed to be directed
    # at Misago Admin and will be checked by Misago Admin Middleware
    url(r"^$", index.admin_index, name="index"),
    url(r"^logout/$", auth.logout, name="logout"),
]

# Discover admin and register patterns
admin.discover_misago_admin()
urlpatterns += admin.urlpatterns()

misago/markup/urls.py
from django.conf.urls import url

from .api import parse_markup

urlpatterns = [url(r"^parse-markup/$", parse_markup, name="parse-markup")]

misago/urls.py
from django.conf.urls import include, url
from django.views.generic import TemplateView

from .conf import settings
from .core.views import forum_index

app_name = "misago"

# Register Misago Apps
urlpatterns = [
    url(r"^", include("misago.analytics.urls")),
    url(r"^", include("misago.legal.urls")),
    url(r"^", include("misago.users.urls")),
    url(r"^", include("misago.categories.urls")),
    url(r"^", include("misago.threads.urls")),
    url(r"^", include("misago.search.urls")),
    # default robots.txt
    url(
        r"^robots.txt$",
        TemplateView.as_view(
            content_type="text/plain", template_name="misago/robots.txt"
        ),
    ),
    # "misago:index" link symbolises "root" of Misago links space
    # any request with path that falls below this one is assumed to be directed
    # at Misago and will be handled by misago.views.exceptionhandler if it
    # results in Http404 or PermissionDenied exception
    url(r"^$", forum_index, name="index"),
]


# Register API
apipatterns = [
    url(r"^", include("misago.categories.urls.api")),
    url(r"^", include("misago.legal.urls.api")),
    url(r"^", include("misago.markup.urls")),
    url(r"^", include("misago.threads.urls.api")),
    url(r"^", include("misago.users.urls.api")),
    url(r"^", include("misago.search.urls.api")),
]

urlpatterns += [url(r"^api/", include((apipatterns, "api"), namespace="api"))]


# Register Misago ACP
if settings.MISAGO_ADMIN_PATH:
    # Admin patterns recognised by Misago
    adminpatterns = [url(r"^", include("misago.admin.urls"))]

    admin_prefix = r"^%s/" % settings.MISAGO_ADMIN_PATH
    urlpatterns += [
        url(admin_prefix, include((adminpatterns, "admin"), namespace="admin"))
    ]

misago/acl/models.py
from django.contrib.postgres.fields import JSONField
from django.db import models
from django.utils.translation import gettext as _

from .cache import clear_acl_cache


def permissions_default():
    return {}


class BaseRole(models.Model):
    name = models.CharField(max_length=255)
    special_role = models.CharField(max_length=255, null=True, blank=True)
    permissions = JSONField(default=permissions_default)

    class Meta:
        abstract = True

    def __str__(self):
        return _(self.name)

    def save(self, *args, **kwargs):
        if self.pk:
            clear_acl_cache()
        return super().save(*args, **kwargs)

    def delete(self, *args, **kwargs):
        clear_acl_cache()
        return super().delete(*args, **kwargs)


class Role(BaseRole):
    pass

misago/cache/models.py
from django.db import models

from .utils import generate_version_string


class CacheVersion(models.Model):
    cache = models.CharField(max_length=128, primary_key=True)
    version = models.CharField(max_length=8, default=generate_version_string)

misago/categories/models.py
from django.core.cache import cache
from django.db import models
from mptt.managers import TreeManager
from mptt.models import MPTTModel, TreeForeignKey

from . import PRIVATE_THREADS_ROOT_NAME, THREADS_ROOT_NAME
from ..acl.cache import clear_acl_cache
from ..acl.models import BaseRole
from ..conf import settings
from ..core.utils import slugify
from ..threads.threadtypes import trees_map

CACHE_NAME = "misago_categories_tree"


class CategoryManager(TreeManager):
    def private_threads(self):
        return self.get_special(PRIVATE_THREADS_ROOT_NAME)

    def root_category(self):
        return self.get_special(THREADS_ROOT_NAME)

    def get_special(self, special_role):
        cache_name = "%s_%s" % (CACHE_NAME, special_role)

        special_category = cache.get(cache_name, "nada")
        if special_category == "nada":
            special_category = self.get(special_role=special_role)
            cache.set(cache_name, special_category)
        return special_category

    def all_categories(self, include_root=False):
        tree_id = trees_map.get_tree_id_for_root(THREADS_ROOT_NAME)
        queryset = self.filter(tree_id=tree_id)
        if not include_root:
            queryset = queryset.filter(level__gt=0)
        return queryset.order_by("lft")

    def get_cached_categories_dict(self):
        categories_dict = cache.get(CACHE_NAME, "nada")
        if categories_dict == "nada":
            categories_dict = self.get_categories_dict_from_db()
            cache.set(CACHE_NAME, categories_dict)
        return categories_dict

    def get_categories_dict_from_db(self):
        categories_dict = {}
        for category in self.all_categories(include_root=True):
            categories_dict[category.pk] = category
        return categories_dict

    def clear_cache(self):
        cache.delete(CACHE_NAME)


class Category(MPTTModel):
    parent = TreeForeignKey(
        "self", null=True, blank=True, related_name="children", on_delete=models.CASCADE
    )
    special_role = models.CharField(max_length=255, null=True, blank=True)
    name = models.CharField(max_length=255)
    slug = models.CharField(max_length=255)
    description = models.TextField(null=True, blank=True)
    is_closed = models.BooleanField(default=False)
    threads = models.PositiveIntegerField(default=0)
    posts = models.PositiveIntegerField(default=0)
    last_post_on = models.DateTimeField(null=True, blank=True)
    last_thread = models.ForeignKey(
        "misago_threads.Thread",
        related_name="+",
        null=True,
        blank=True,
        on_delete=models.SET_NULL,
    )
    last_thread_title = models.CharField(max_length=255, null=True, blank=True)
    last_thread_slug = models.CharField(max_length=255, null=True, blank=True)
    last_poster = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        related_name="+",
        null=True,
        blank=True,
        on_delete=models.SET_NULL,
    )
    last_poster_name = models.CharField(max_length=255, null=True, blank=True)
    last_poster_slug = models.CharField(max_length=255, null=True, blank=True)
    require_threads_approval = models.BooleanField(default=False)
    require_replies_approval = models.BooleanField(default=False)
    require_edits_approval = models.BooleanField(default=False)
    prune_started_after = models.PositiveIntegerField(default=0)
    prune_replied_after = models.PositiveIntegerField(default=0)
    archive_pruned_in = models.ForeignKey(
        "self",
        related_name="pruned_archive",
        null=True,
        blank=True,
        on_delete=models.SET_NULL,
    )
    css_class = models.CharField(max_length=255, null=True, blank=True)

    objects = CategoryManager()

    def __str__(self):
        return str(self.thread_type.get_category_name(self))

    @property
    def thread_type(self):
        return trees_map.get_type_for_tree_id(self.tree_id)

    def delete(self, *args, **kwargs):
        Category.objects.clear_cache()
        clear_acl_cache()
        return super().delete(*args, **kwargs)

    def synchronize(self):
        threads_queryset = self.thread_set.filter(is_hidden=False, is_unapproved=False)
        self.threads = threads_queryset.count()

        if self.threads:
            replies_sum = threads_queryset.aggregate(models.Sum("replies"))
            self.posts = self.threads + replies_sum["replies__sum"]
        else:
            self.posts = 0

        if self.threads:
            last_thread_qs = threads_queryset.filter(
                is_hidden=False, is_unapproved=False
            )
            last_thread = last_thread_qs.order_by("-last_post_on")[:1][0]
            self.set_last_thread(last_thread)
        else:
            self.empty_last_thread()

    def delete_content(self):
        from .signals import delete_category_content

        delete_category_content.send(sender=self)

    def move_content(self, new_category):
        from .signals import move_category_content

        move_category_content.send(sender=self, new_category=new_category)

    def get_absolute_url(self):
        return self.thread_type.get_category_absolute_url(self)

    def get_last_thread_url(self):
        return self.thread_type.get_category_last_thread_url(self)

    def get_last_thread_new_url(self):
        return self.thread_type.get_category_last_thread_new_url(self)

    def get_last_post_url(self):
        return self.thread_type.get_category_last_post_url(self)

    def set_name(self, name):
        self.name = name
        self.slug = slugify(name)

    def set_last_thread(self, thread):
        self.last_post_on = thread.last_post_on
        self.last_thread = thread
        self.last_thread_title = thread.title
        self.last_thread_slug = thread.slug
        self.last_poster = thread.last_poster
        self.last_poster_name = thread.last_poster_name
        self.last_poster_slug = thread.last_poster_slug

    def empty_last_thread(self):
        self.last_post_on = None
        self.last_thread = None
        self.last_thread_title = None
        self.last_thread_slug = None
        self.last_poster = None
        self.last_poster_name = None
        self.last_poster_slug = None

    def has_child(self, child):
        return child.lft > self.lft and child.rght < self.rght


class CategoryRole(BaseRole):
    pass


class RoleCategoryACL(models.Model):
    role = models.ForeignKey(
        "misago_acl.Role", related_name="categories_acls", on_delete=models.CASCADE
    )
    category = models.ForeignKey(
        "Category", related_name="category_role_set", on_delete=models.CASCADE
    )
    category_role = models.ForeignKey(CategoryRole, on_delete=models.CASCADE)

misago/conf/models.py
from pathlib import Path

from django.contrib.postgres.fields import JSONField
from django.db import models

from ..core.utils import get_file_hash
from .hydrators import dehydrate_value, hydrate_value


class SettingsManager(models.Manager):
    def change_setting(self, setting, dry_value=None, wet_value=None):
        if dry_value:
            return self.filter(setting=setting).update(dry_value=dry_value)

        if wet_value:
            try:
                setting = self.get(setting=setting)
                setting.value = wet_value
                setting.save(update_fields=["dry_value"])
            except Setting.DoesNotExist:
                return 0


class Setting(models.Model):
    setting = models.CharField(max_length=255, unique=True)
    python_type = models.CharField(max_length=255, default="string")
    dry_value = models.TextField(null=True, blank=True)
    image = models.ImageField(
        upload_to="conf",
        height_field="image_height",
        width_field="image_width",
        null=True,
        blank=True,
    )
    image_size = models.PositiveIntegerField(null=True, blank=True)
    image_width = models.PositiveIntegerField(null=True, blank=True)
    image_height = models.PositiveIntegerField(null=True, blank=True)
    is_public = models.BooleanField(default=False)
    is_lazy = models.BooleanField(default=False)

    objects = SettingsManager()

    @property
    def image_dimensions(self):
        if self.image_width and self.image_height:
            return self.image_width, self.image_height
        return None

    @property
    def value(self):
        if self.python_type == "image":
            return self.image
        return hydrate_value(self.python_type, self.dry_value)

    @value.setter
    def value(self, new_value):
        if new_value is not None:
            if self.python_type == "image":
                rename_image_file(new_value, self.setting)
                self.image = new_value
                self.image_size = new_value.size
            else:
                self.dry_value = dehydrate_value(self.python_type, new_value)
        else:
            self.dry_value = None
        return new_value


def rename_image_file(file_obj, prefix):
    name_parts = [
        prefix.replace("_", "-"),
        get_file_hash(file_obj),
        Path(file_obj.name).suffix.strip(".").lower(),
    ]
    file_obj.name = ".".join(name_parts)

misago/core/testproject/models.py
class Model:
    def __init__(self, pk, slug):
        self.id, self.pk = pk, pk
        self.slug = slug

misago/readtracker/models.py
from django.conf import settings
from django.db import models
from django.utils import timezone


class PostRead(models.Model):
    user = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE)
    category = models.ForeignKey("misago_categories.Category", on_delete=models.CASCADE)
    thread = models.ForeignKey("misago_threads.Thread", on_delete=models.CASCADE)
    post = models.ForeignKey("misago_threads.Post", on_delete=models.CASCADE)
    last_read_on = models.DateTimeField(default=timezone.now)

misago/threads/models/attachmenttype.py
from django.db import models
from django.utils.translation import gettext_lazy as _


class AttachmentType(models.Model):
    ENABLED = 0
    LOCKED = 1
    DISABLED = 2

    name = models.CharField(max_length=255)
    extensions = models.CharField(max_length=255)
    mimetypes = models.CharField(null=True, blank=True, max_length=255)
    size_limit = models.PositiveIntegerField(default=1024)
    status = models.PositiveIntegerField(
        default=ENABLED,
        choices=[
            (ENABLED, _("Allow uploads and downloads")),
            (LOCKED, _("Allow downloads only")),
            (DISABLED, _("Disallow both uploading and downloading")),
        ],
    )

    limit_uploads_to = models.ManyToManyField(
        "misago_acl.Role", related_name="+", blank=True
    )
    limit_downloads_to = models.ManyToManyField(
        "misago_acl.Role", related_name="+", blank=True
    )

    def __str__(self):
        return self.name

    @property
    def is_enabled(self):
        return self.status == AttachmentType.ENABLED

    @property
    def is_locked(self):
        return self.status == AttachmentType.LOCKED

    @property
    def extensions_list(self):
        if self.extensions:
            return self.extensions.split(",")
        return []

    @property
    def mimetypes_list(self):
        if self.mimetypes:
            return self.mimetypes.split(",")
        return []

misago/threads/models/pollvote.py
from django.conf import settings
from django.db import models
from django.utils import timezone


class PollVote(models.Model):
    category = models.ForeignKey("misago_categories.Category", on_delete=models.CASCADE)
    thread = models.ForeignKey("misago_threads.Thread", on_delete=models.CASCADE)
    poll = models.ForeignKey("misago_threads.Poll", on_delete=models.CASCADE)
    voter = models.ForeignKey(
        settings.AUTH_USER_MODEL, blank=True, null=True, on_delete=models.SET_NULL
    )
    voter_name = models.CharField(max_length=255)
    voter_slug = models.CharField(max_length=255)
    voted_on = models.DateTimeField(default=timezone.now)
    choice_hash = models.CharField(max_length=12, db_index=True)

    class Meta:
        index_together = [["poll", "voter_name"]]

misago/users/models/activityranking.py
from django.conf import settings
from django.db import models


class ActivityRanking(models.Model):
    user = models.ForeignKey(
        settings.AUTH_USER_MODEL, related_name="+", on_delete=models.CASCADE
    )
    score = models.PositiveIntegerField(default=0, db_index=True)

misago/templates/misago/admin/base.html
{% load i18n static %}
<!doctype html>
<html lang="{{ LANGUAGE_CODE }}">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>{% spaceless %}{% block title %}{% trans "Misago Administration" %}{% endblock %}{% endspaceless %}</title>
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.2/css/all.css" integrity="sha384-fnmOCqbTlWIlj8LyTjo7mOUStjsKC4pOpQbqyi7RrhN7udi9RwhKkMHpvLbHG9Sr" crossorigin="anonymous">
    <link href="{% static 'misago/admin/index.css' %}" rel="stylesheet">
    <link rel="apple-touch-icon" href="{% static 'apple-touch-icon.png' %}">
    <link rel="apple-touch-icon" sizes="57x57" href="{% static 'apple-touch-icon-57.png' %}">
    <link rel="apple-touch-icon" sizes="72x72" href="{% static 'apple-touch-icon-72.png' %}">
    <link rel="apple-touch-icon" sizes="76x76" href="{% static 'apple-touch-icon-76.png' %}">
    <link rel="apple-touch-icon" sizes="80x80" href="{% static 'apple-touch-icon-80.png' %}">
    <link rel="apple-touch-icon" sizes="114x114" href="{% static 'apple-touch-icon-114.png' %}">
    <link rel="apple-touch-icon" sizes="120x120" href="{% static 'apple-touch-icon-120.png' %}">
    <link rel="apple-touch-icon" sizes="144x144" href="{% static 'apple-touch-icon-144.png' %}">
    <link rel="apple-touch-icon" sizes="152x152" href="{% static 'apple-touch-icon-152.png' %}">
    <link rel="apple-touch-icon" sizes="167x167" href="{% static 'apple-touch-icon-167.png' %}">
    <link rel="apple-touch-icon" sizes="180x180" href="{% static 'apple-touch-icon-180.png' %}">
    <link rel="shortcut icon" href="{% static 'favicon.ico' %}">
    <link rel="icon" sizes="16x16 32x32" href="{% static 'favicon.ico' %}">
    {% block extra-head %}{% endblock extra-head %}
  </head>
  {% block body %}{% endblock %}
</html>

misago/templates/misago/admin/layout.html
{% extends "misago/admin/base.html" %}
{% load static %}


{% block body %}
<body>
  {% include "misago/admin/navbar.html" %}

  <div class="container-fluid my-3 pb-3">
    <div class="row">
      <div class="col col-nav-side">
        {% include "misago/admin/sidenav.html" %}
      </div>
      <div class="col">
        {% include "misago/admin/messages.html" %}
        {% block content %}{% endblock %}
      </div>
    </div>
  </div>

  {# We include JavaScript at the end of page body so it renders faster #}
  <script type="text/javascript" src="{% static 'misago/admin/index.js' %}"></script>
  {% if ADMIN_MOMENTJS_LOCALE_URL %}
    <script type="text/javascript" src="{% static ADMIN_MOMENTJS_LOCALE_URL %}"></script>
  {% endif %}
  <script type="text/javascript">
    window.misago.init()
  </script>
  {% block javascripts %}{% endblock javascripts %}
</body>
{% endblock body %}

misago/templates/misago/admin/login.html
{% extends "misago/admin/base.html" %}
{% load i18n static %}


{% block title %}
  {% trans "Log in" %} | {% if target == "django" %}{% trans "Django Administration" %}{% else %}{% trans "Misago Administration" %}{% endif %}
{% endblock %}


{% block body %}
<body class="login-form">
  <form class="login-form-container" method="post" role="form">
    {% csrf_token %}
    <div class="login-form-logo">
      {% if target == "misago" %}
        <img src="{% static 'misago/admin/img/misago.png' %}" alt="Misago">
      {% elif target == "django" %}
        <img src="{% static 'misago/admin/img/django.png' %}" alt="Django">
      {% endif  %}
    </div>

    <div class="card login-form-card">
      <div class="card-body">
        <h1 class="card-title login-form-title">{% trans "Administration" %}</h1>

        {% for error in form.non_field_errors %}
          <p class="alert alert-danger text-center" role="alert">
            {{ error }}
            <br>{% trans "Please try again." %}
          </p>
        {% endfor %}
        {% for message in messages %}
          {% if 'success' in message.tags %}
            <div class="alert alert-success text-center" role="alert">
          {% elif 'warning' in message.tags %}
            <div class="alert alert-warning text-center" role="alert">
          {% elif 'error' in message.tags %}
            <div class="alert alert-danger text-center" role="alert">
          {% else %}
            <div class="alert alert-info text-center" role="alert">
          {% endif %}
              {{ message }}
            </div>
        {% endfor %}

        <div class="form-group">
          <div class="control-input">
            <input type="text" name="username" class="form-control input-lg" placeholder="{% trans "Username or e-mail" %}" {% if form.username.value %}value="{{ form.username.value }}"{% endif %}>
          </div>
        </div>
        <div class="form-group">
          <div class="control-input">
            <input type="password" name="password" class="form-control input-lg" placeholder="{% trans "Password" %}">
          </div>
        </div>
        <button class="btn btn-primary btn-block">
          {% trans "Sign in" %}
        </button>
        <a href="{% url 'misago:index' %}" class="btn btn-light btn-block">
          {% trans "Return to site" %}
        </a>
      </div>
    </div>
  </form>
</body>
{% endblock body %}

misago/templates/misago/admin/messages.html
{% load i18n %}
{% for message in messages %}
  {% if 'info' in message.tags %}
    <p class="alert alert-info text-center">
  {% elif 'success' in message.tags %}
    <p class="alert alert-success text-center">
  {% elif 'warning' in message.tags %}
    <p class="alert alert-warning text-center">
  {% elif 'error' in message.tags %}
    <p class="alert alert-danger text-center">
  {% endif %}
    {{ message }}
  </p>
{% endfor %}

misago/templates/misago/admin/navbar.html
{% load i18n static misago_avatars %}
<nav class="navbar navbar-expand-lg navbar-light bg-white shadow-sm">
  <a class="navbar-brand" href="{% url 'misago:admin:index' %}">
    <img src="{% static 'misago/admin/img/mred.png' %}" alt="">
    <span>Misago</span>
  </a>
  <span class="badge badge-light mr-auto">
    {{ MISAGO_VERSION }}
  </span>
  <a href="https://github.com/rafalp/misago" target="_blank" class="btn btn-light btn-sm mr-3">
    <span class="fab fa-github"></span>
    {% trans "GitHub" %}
  </a>
  <a href="https://misago-project.org" target="_blank" class="btn btn-light btn-sm mr-3">
    <span class="far fa-question-circle"></span>
    {% trans "Support forum" %}
  </a>
  <a href="{% url 'misago:index' %}" class="btn btn-light btn-sm mr-3">
    <span class="far fa-window-maximize"></span>
    {% trans "Site index" %}
  </a>
  <div class="dropdown">
    <button type="button" class="btn btn-user dropdown-toggle" id="openAdminDropdown" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
      <img src="{{ user|avatar:30 }}" alt="{% trans 'Your avatar' %}">
    </button>
    <div class="dropdown-menu dropdown-menu-right" aria-labelledby="openAdminDropdown">
      <h6 class="dropdown-header">{{ user }}</h6>
      <a class="dropdown-item" href="{% url 'misago:admin:users:edit' pk=user.pk %}">
        {% trans "Edit your account" %}
      </a>
      <div class="dropdown-divider"></div>
      <form action="{% url 'misago:admin:logout' %}" method="post">
        {% csrf_token %}
        <button type="submit" class="dropdown-item">
          {% trans "Close admin session" %}
        </button>
      </form>
      <form action="{% url 'misago:logout' %}" method="post">
        {% csrf_token %}
        <button type="submit" class="dropdown-item">
          {% trans "Log out completely" %}
        </button>
      </form>
    </div>
  </div>
</nav>

misago/templates/misago/admin/permissions_table.html
{% load i18n misago_admin_form %}
<div class="form-fieldset">
  <fieldset>
    <legend>{{ form.legend }}</legend>
    {% for field in form %}
      {% form_row field %}
    {% endfor %}
  </fieldset>
</div>

misago/templates/misago/admin/sidenav.html
{% load i18n %}
<nav class="nav nav-side">
  {% for node in sections %}
    <a class="nav-link nav-section{% if node.is_active %} active{% endif %}" href="{{ node.link }}">
      <div class="media-icon">
        <span class="{{ node.icon }}"></span>
      </div>
      <div class="media-body">
        {{ node.name }}
      </div>
    </a>
    {% if node.is_active and actions %}
      {% for subnode in actions %}
        <a class="nav-link nav-action{% if subnode.is_active %} active{% endif %}" href="{{ subnode.link }}">
          <div class="media-body">
            {{ subnode.name }}
          </div>
        </a>
      {% endfor %}
    {% endif %}
  {% endfor %}
</nav>